#!/usr/bin/env python

"""
Function which accepts two AAstrings of pdbA and pdbB
and returns %Homology and suggests pdb to retain by default its larger
pdb
"""
import pdb2fasta

def maxLastIndex(x,i,z,query,fasta):
    #print 'Here Dude'
    while i>z:
        if query[x:i] in fasta:
            #print 'ynew=%d' % (i)
            return i
        i-=1
    #print 'ynew=%d' % (i)
    return i

def minFirstIndex(i,y,z,query,fasta):
    
    while i<=z:
        #print 'i= %d' % (i)
        if query[i:y] in fasta:
            return i
        i+=1
    return i

def seqHomology(fA,fB,lA,lB):

    
    #print 'fA = %s ; fB = %s ; lA = %d ; lB=%d' %(fA,fB,lA,lB)
    out=[]
    outA=[]
    outB=[]
    #Switch flag for change in A/b wrt to size
    sw=0
    threshold=100  #Edit Threshold for removing a smaller PDB here. It is the maximum difference between two redundant PDBs before one can be removed
    tmpL=0
    H_L=0
    H_L1=0
    H_L2=0
    tmpF=''

    H_A=0
    H_B=0
    R_A=1 #Retain A default Yes
    R_B=1 #Retain B default Yes
    B_counter=0
    
    #Put smaller sequence in A, also sw=1 implies a switch has taken place
    if lA>lB:
        tmpF=fA
        fA=fB
        fB=tmpF
        tmpL=lA
        lA=lB
        lB=tmpL        
        sw=1

    tmpL=0
    tmpF=''
    """
    Homology Calculation
    """
    
    if fA in fB:
        #print 'YES!'
        R_A=0
        R_B=1
        H_L1=lA
        B_counter=fB.count(fA)
    
    else:
      
        x=int(lA/4)
        y=int(3*lA/4)
        z=int(lA/2)
        subA1=fA[x:z]
        subA2=fA[z:y]
        #subA1+A2=f[x:y]
        #print 'subA1+A2 = %s;' %(fA[x:y])
        #print x
        #print y
        #print z
        #print len(fA[x:y])
        #print 'I came here dude'

        if fA[x:y] in fB:
            #print 'WTF'
            #print 'I came here subA1 + subA2'
            while (x>=0)and (fA[x:y] in fB):
                x=x-1
            x+=1
            #print 'final x = %d'%(x)

            while (y<=lA)and (fA[x:y] in fB):
                y=y+1
            y-=1
            #print 'subA1+A2 = %s;' %(fA[x:y])
            
            #print 'final y = %d'%(y)
            #print len(fA[x:y])
            H_L=y-x        
            B_counter=fB.count(fA[x:y])
            #print fB.find(fA[x:y]) 
            #print B_counter
        else:
            #print 'i came here'
            #print subA1
            #print subA2

            if subA1 in fB:
                #print 'subA1 is there'
                y=maxLastIndex(x,y,z,fA,fB)
                subA1=fA[x:y]
                #print 'x = %d' % (x)
                #print 'y = %d' % (y)
                #print 'subA1 = %s;' %(fA[x:y])
                
                while(x>=0) and subA1 in fB:
                    x=x-1
                    subA1=fA[x:y]
                x+=1
                #print 'subA1 = %s;' %(fA[x:y])
                #print x
                #print y
                #print len(fA[x:y])
                B_counter=fB.count(fA[x:y])
                H_L1=y-x

            x=int(lA/4)
            y=int(3*lA/4)
            z=int(lA/2)
            subA1=fA[x:z]
            subA2=fA[z:y]
            
            if subA2 in fB:
                #print 'subA2 is there'
                x=minFirstIndex(x,y,z,fA,fB)
                subA2=fA[x:y]
                #print 'x = %d' % (x)
                                   
                while(y<=lA) and fA[x:y] in fB:
                    y=y+1
                    
                subA2=fA[x:y]
                #print 'subA2 = %s;' %(fA[x:y])
                #print x
                #print y
                #print len(fA[x:y])
                B_counter=fB.count(fA[x:y])
                H_L2=y-x
                            
    # print 'H_L1, H_L1 and H_L2 and B_counter and LA and LB = %d,%d,%d,%d,%d,%d' %(H_L,H_L1,H_L2,B_counter,lA,lB) 
    H_A=float(max(H_L,H_L1,H_L2))/float(lA)*100
    #print 'H_A = %f' %(H_A)
    H_B=float(B_counter*H_A*lA)/float(lB)
    #print 'H_B = %f' %(H_B)

    
    if H_A>float(50):
        R_A=0
    if lB-lA>threshold:
        R_A=R_B=1
        
    outA=[round(H_A,2),R_A] #Out is a list not string
    outB=[round(H_B,2),R_B]
    
    if outA[0]==0:
        outA[0]='<25'
        outB[0]='<25'
        
    if sw==1:
        out=out+outB
        out=out+outA
    else:
        out+=outA
        out+=outB
    
    #print out
    #print 'seqHomologyout here <-'
    return out

#Each line in pdbs should be like this "AARATKAKAJD...."

import os

def checkHomology(path,level,pdb_A,otherPdb):
    
    chain ="A"        #Program checks chain A of both strings by default
    atomseq=False     #Uses SEQRES by default
       
    #pdbA->sAA sequence string
    pdb_A_id = pdb_A.split('.')[0]
    f = open(os.path.join(path,pdb_A),'r')
    pdbA = f.readlines()
    f.close()
    fastaA = pdb2fasta.pdb2Fasta(pdbA,pdb_A_id,atomseq)

    #pdbB->sAA sequence string   
    pdb_B_id = otherPdb.split('.')[0]
    f = open(os.path.join(path,otherPdb),'r')
    pdbB = f.readlines()
    f.close()
    fastaB = pdb2fasta.pdb2Fasta(pdbB,pdb_B_id,atomseq)

    lenA=len(fastaA)
    lenB=len(fastaB)
    
    out=[]
    H=[]
    #Element in out should be like this ["1XR3","1QRE",43,76,0,1] and in H like [43,0,76,1]
    
    outH=seqHomology(fastaA,fastaB,lenA,lenB)

    out.append(pdb_A_id)
    out.append(pdb_B_id)
    out.append(outH)
    
    return out



def main():
    """
    Function to execute if called from command line.
    """
    
    chain ="A"
    atomseq=False
    pdb_A="3F0Q.pdb"
    pdb_B="3FOQ.pdb"
    path=''
    level=1 
       
    H = checkHomology(path,level,pdb_A,pdb_B)

    print type(H),
    print H
    


if __name__ == "__main__":
    main()

