"""
This is the main file with the main fuction
and the father function processPdbSet
which calls its daughter functions.
In the given pdbSet it truncates redundant pdbs (%>50) and prints result in trunc_Pdblib.txt
It prints homology data in H_data.txt 
"""
import os
import glob
import shutil

import checkHomology

def processPdbSet(path):
    
    print'%s \n PROCESSING \n %s\n' % ('*'*10,'*'*10)
    #Default Variables
    registryname='registry.reg'
    done = 0
    level=0 #Directory level of sequences
    level=len(path.split('/'))
    
    
    #Sets default value of pdbs 'not done'
    registry_dict=dict([(pdb_file.split('/')[level],'not done') for pdb_file in glob.glob(os.path.join(path,'*.pdb'))])
    Seq_dict=dict()
    R_dict=dict([(pdb_file.split('/')[level],1) for pdb_file in glob.glob(os.path.join(path,'*.pdb'))])
                        
    out=[] #Contains the data of the pdb processed in use
    
    for key in registry_dict.keys():
        registry_dict[key]="Processed" #Update value of pdb in use

        for rest in registry_dict.keys():
            Seq_dict[key,key]=100
            if registry_dict[rest]=='not done':
                out= checkHomology.checkHomology(path,level,key,rest)
                print out
               
                Seq_dict[key,rest]=out[2][0] #The key values tells how much of key sequence is homologous to rest
		                
		Seq_dict[rest,key]=out[2][2]
		
                if R_dict[key] is 1 and out[2][1]==0:
		    print 2
                    R_dict[key]=0
                    
                if R_dict[rest] is 1 and out[2][3]==0:
                    print 2
		    R_dict[rest]=0
        
    
    #Open file here and print on the first line
    f=open(os.path.join(path,'H_table.txt'),'w')
    f.write('\n\t %s PDB Sequence Identities %s \t\n\n' % ('*'*20,'*'*20))
    f.write('\t\t')
    for key in registry_dict.keys():
        f.write('%s\t'%(key.split('.')[0]),)
    f.write('\n')
    for key1 in registry_dict.keys():
        f.write('%s \t'%(key1.split('.')[0]))
        for key2 in registry_dict.keys():
            f.write(str(Seq_dict[(key1,key2)]))
            f.write(',\t')
        f.write('\n')
    f.write('\n\t %s %s \t\n' % ('*'*30,'*'*30))
    f.write("\n (Row,Column)'s Value gives %of ROW_PDB_ID Sequence identified in COLUMN_PDB_ID \n\n")

    f.close()
    
    f=open(os.path.join(path,'trunc_PDBLib.txt'),'w')
    f.write('\t %s Non-Redundant PDB Set %s \t\n' % ('*'*20,'*'*20))
    f.write('PDB_FILE\tKEEP\n')
    for key in R_dict.keys():
        f.write('%s\t%d' % (key,R_dict[key]))
        f.write('\n')
    f.write('\n\t %s %s \t\n' % ('*'*30,'*'*30))
    
    
    f.close()

    if not os.path.exists(os.path.join(path,'RedundantSet')):
                          os.mkdir(os.path.join(path,'RedundantSet'))
                          
    for key in registry_dict.keys():
	print R_dict[key]
	print key        
	if R_dict[key]==0:
            print'\n %s \n %s has been moved to folder RedundantSet \n %s \n' % ('#'*10,key,'#'*10)
            shutil.move(os.path.join(path,key),os.path.join(path,'RedundantSet'))
        
    print'%s \n DONE! \n Check %s \n %s\n' % ('*'*10,path,'*'*10)
   
        


def main():
    path = '/home/gaurav/Validation_Toolkit/Data_Redundancy/PDB'  #Change path to PDBs Folder ex: 'C:\YOURPATH1\YOURPATH2'
    processPdbSet(path)
    
    
if __name__ == "__main__":
    main()
                         
